#
# Conditional build:
%bcond_with	doc	# Sphinx documentation (need to wait for fulfilling dependencies in PLD)
%bcond_with	tests	# unit tests (need to wait for fulfilling dependencies in PLD)

Summary:	An enhanced Interactive Python shell
Summary(pl.UTF-8):	Interaktywna powłoka języka Python
Name:		ipython3
Version:	5.8.0
Release:	3
License:	BSD
Group:		Applications/Shells
Source0:	http://archive.ipython.org/release/%{version}/ipython-%{version}.tar.gz
# Source0-md5:	7014b8824981eef2cb893ea5398d6b8d
Patch0:		ipython-use-setuptools.patch
URL:		http://ipython.org/
BuildRequires:	pydoc3 >= 1:3.3
BuildRequires:	python3-devel >= 1:3.3
BuildRequires:	python3-devel-tools >= 1:3.3
BuildRequires:	python3-setuptools >= 18.5
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.714
%if %{with tests}
BuildRequires:	python3-decorator
BuildRequires:	python3-ipykernel
BuildRequires:	python3-nbformat
BuildRequires:	python3-nose >= 0.10.1
%if "%{py3_ver}" >= "3.4"
BuildRequires:	python3-numpy
%endif
%if "%{py3_ver}" < "3.4"
BuildRequires:	python3-pathlib2
%endif
BuildRequires:	python3-pexpect
BuildRequires:	python3-pickleshare
BuildRequires:	python3-prompt_toolkit >= 1.0.4
BuildRequires:	python3-prompt_toolkit < 2
BuildRequires:	python3-pygments
BuildRequires:	python3-requests
BuildRequires:	python3-simplegeneric >= 0.8
BuildRequires:	python3-testpath
BuildRequires:	python3-traitlets >= 4.2
%endif
%if %{with doc}
BuildRequires:	python3-docutils
BuildRequires:	python3-ipykernel
BuildRequires:	python3-sphinx_rtd_theme
BuildRequires:	sphinx-pdg-3 >= 1.3
%endif
Requires:	python3-ipython = %{version}-%{release}
Suggests:	python3-PyQt5
Suggests:	python3-zmq
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
IPython is a free software project which tries to:

1. Provide an interactive interpreter superior to Python's default.
IPython has many features for object introspection, shell access, and
its own special command system for adding functionality when working
interactively.

2. Serve as an embeddable, ready to use interpreter for your own
programs. IPython can be started with a single call from inside
another program, providing access to the current namespace. This can
be very useful both for debugging purposes and for situations where a
blend of batch-processing and interactive exploration are needed.

3. Offer a flexible framework which can be used as the base
environment for other systems with Python as the underlying language.
Specifically scientific environments like Mathematica, IDL and Mathcad
inspired its design, but similar ideas can be useful in many fields.

This package contains IPython shell.

%description -l pl.UTF-8
IPython jest wolnym oprogramowaniem, którego celem jest:

1. Dostarczenie interaktywnej powłoki lepszej od standardowej
dostarczanej z językiem Python. IPython umożliwia badanie obiektów,
dostęp do powłoki oraz własny system poleceń, który umożliwia
rozszerzanie funkcjonalności podczas pracy interaktywnej.

2. Dostarczenie gotowego interpretera, który można dołączać do własnej
aplikacji. IPython może zostać uruchomiony za pomocą wywołania jednej
funkcji z poziomu innego programu umożliwiając jednocześnie dostęp do
aktualnej przestrzeni nazw tego programu. Może to być bardzo użyteczne
do celów takich jak śledzenie programu czy też sytuacji gdzie jest
wymagane połączenie przetwarzania wsadowego z interaktywną
introspekcją.

3. Dostarczenie szkieletu, który może zostać użyty jako podstawa
systemu, którego polecenia opierają się na zasadach języka Python.
Projekt został zainspirowany przez oprogramowanie naukowe takie jak
Mathematica, IDL oraz Mathcad, gdzie podobne idee mogą być realizowane
w wielu przypadkach.

Pakiet ten zawiera powłokę IPython.

%package -n python3-ipython
Summary:	An enhanced Interactive Python shell modules
Summary(pl.UTF-8):	Moduły interaktywnej powłoki języka Python
Group:		Libraries/Python
Requires:	pydoc3 >= 1:3.3
Requires:	python3-devel-tools >= 1:3.3

%description -n python3-ipython
IPython is a free software project which tries to:

1. Provide an interactive interpreter superior to Python's default.
IPython has many features for object introspection, shell access, and
its own special command system for adding functionality when working
interactively.

2. Serve as an embeddable, ready to use interpreter for your own
programs. IPython can be started with a single call from inside
another program, providing access to the current namespace. This can
be very useful both for debugging purposes and for situations where a
blend of batch-processing and interactive exploration are needed.

3. Offer a flexible framework which can be used as the base
environment for other systems with Python as the underlying language.
Specifically scientific environments like Mathematica, IDL and Mathcad
inspired its design, but similar ideas can be useful in many fields.

This package contains IPython modules.

%description -n python3-ipython -l pl.UTF-8
IPython jest wolnym oprogramowaniem, którego celem jest:

1. Dostarczenie interaktywnej powłoki lepszej od standardowej
dostarczanej z językiem Python. IPython umożliwia badanie obiektów,
dostęp do powłoki oraz własny system poleceń, który umożliwia
rozszerzanie funkcjonalności podczas pracy interaktywnej.

2. Dostarczenie gotowego interpretera, który można dołączać do własnej
aplikacji. IPython może zostać uruchomiony za pomocą wywołania jednej
funkcji z poziomu innego programu umożliwiając jednocześnie dostęp do
aktualnej przestrzeni nazw tego programu. Może to być bardzo użyteczne
do celów takich jak śledzenie programu czy też sytuacji gdzie jest
wymagane połączenie przetwarzania wsadowego z interaktywną
introspekcją.

3. Dostarczenie szkieletu, który może zostać użyty jako podstawa
systemu, którego polecenia opierają się na zasadach języka Python.
Projekt został zainspirowany przez oprogramowanie naukowe takie jak
Mathematica, IDL oraz Mathcad, gdzie podobne idee mogą być realizowane
w wielu przypadkach.

Pakiet ten zawiera moduły interaktywnej powłoki języka Python.

%prep
%setup -q -n ipython-%{version}
%patch0 -p1

%build
%py3_build

%if %{with tests}
%{__python3} IPython/testing/iptest.py IPython
%endif

%if %{with doc}
PYTHONPATH=$(pwd) \
%{__make} -C docs html \
	SPHINXBUILD=sphinx-build-3
%endif

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}

%py3_install

cp -pr examples/* $RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}

# test suite
%{__rm} $RPM_BUILD_ROOT%{_bindir}/iptest*
%{__rm} -r $RPM_BUILD_ROOT%{py3_sitescriptdir}/IPython/{core/tests,extensions/tests,lib/tests,terminal/tests,testing/tests,utils/tests}

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/ipython
%attr(755,root,root) %{_bindir}/ipython3
%{_mandir}/man1/ipython.1*

%files -n python3-ipython
%defattr(644,root,root,755)
%doc COPYING.rst README.rst
%{py3_sitescriptdir}/IPython
%{py3_sitescriptdir}/ipython-%{version}-py*.egg-info
%{_examplesdir}/%{name}-%{version}
%changelog
* Mon Oct 28 2019 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/ipython3.git;a=log;h=auto/th/ipython3-5.8.0-3

* Mon Oct 28 2019 Jan Rękorajski <baggins@pld-linux.org> 1d6117a
- rebuild with python 3.8
- release 3 (by relup.sh)

* Sun Sep 22 2019 Jakub Bogusz <qboosh@pld-linux.org> 70e8920
- testing dir is needed for debugger; release 2

* Sun Sep 22 2019 Jakub Bogusz <qboosh@pld-linux.org> d0972d0
- updated to 5.8.0 for now (there is also py3-only 7.7.0, but requires more python3 specific updates)
- added use-setuptools patch to generate pythonegg dependencies

* Sun Jul 01 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 3b548c0
- python 3.7 rebuild
- release 3 (by relup.sh)

* Tue Mar 28 2017 Jan Rękorajski <baggins@pld-linux.org> 2598457
- fix typo in Reqs
- rel 2

* Mon Mar 27 2017 Mateusz Korniak <matkor@pld-linux.org> c5cd9c4
- up to 5.3.0 release 1

* Thu Dec 29 2016 Arkadiusz Miśkiewicz <arekm@maven.pl> 7dc91e1
- python 3.6
- release 4 (by relup.sh)

* Sun Apr 17 2016 Jan Rękorajski <baggins@pld-linux.org> 7b6aa74
- use macro for installing
- rel 3

* Sun Apr 17 2016 Jan Rękorajski <baggins@pld-linux.org> 307a5e7
- updated md5sum

* Sat Nov 28 2015 Jacek Konieczny <jajcus@jajcus.net> 4514da6
- release 2 (by relup.sh)

* Sun Sep 13 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> 8b26655
- up to 4.0.0

* Sun Sep 13 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> 3eb943b
- release 3 (by relup.sh)

* Sun Sep 13 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> 389894d
- python 3.5 rebuild
- release 2 (by relup.sh)

* Fri Mar 13 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> 0cd7ee8
- up to 3.0.0

* Sun Oct 19 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> a8c881b
- python 3.4
- release 2 (by relup.sh)

* Thu Apr 03 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> ca385af
- up to 2.0.0 (upstream back to being coflicting with python2 version; we follow

* Sun Feb 23 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> fbf170a
- ipython3 notebook needs python3-jinja2

* Sun Feb 23 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> bf370fb
- up to 1.2.0

* Mon Aug 26 2013 wrobell <wrobell@pld-linux.org> 240bfbd
- ver. 1.0.0

* Thu Aug 15 2013 Kacper Kornet <draenog@pld-linux.org> 5223526
- add missing R: python3-distribute

